<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:rich="http://richfaces.org/rich"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.tm.TestExecution']}"/>
    <ui:param name="containerStyle" value="gzl-container-fluid"/>
    <ui:define name="body">
        <s:div styleClass="gzl-alert gzl-alert-red" rendered="#{!testExecutionBeanGui.isAbleToStartTestInstance()}">
            <h:outputText value="#{messages['net.ihe.gazelle.tm.TheSessionIsClosedYouCanNotStartANewTestInstance']}"/>
        </s:div>
        <h:form id="presetForm">
            <s:div styleClass="row preset"
                   rendered="#{!quickFilterBean.getQuickFilters().isEmpty()}">
                <div class="col-md-2">
                    <h4>
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.QuickFilters']}"/>
                    </h4>
                </div>
                <a4j:repeat id="quickFilters" value="#{quickFilterBean.getQuickFilters()}"
                            var="quickFilter">
                    <div class="col-md-2">
                        <h4>
                            <h:commandLink execute="@this"
                                           style="#{quickFilterBean.getCurrentQuickFilterStyle(quickFilter)}"
                                           action="#{quickFilter.getUrl()}"
                                           value="#{quickFilter.getDisplayName()}"/>

                            <h:commandLink execute="@this"
                                           title="#{messages['net.ihe.gazelle.tm.CheckIfYouWantToMakeItYourDefaultPage']}"
                                           action="#{quickFilterBean.setDefaultQuickFilter(quickFilter)}">
                                <s:span styleClass="fa gzl-icon-star-o" rendered="#{!quickFilter.isDefaultFilter()}"/>
                                <s:span styleClass="fa gzl-icon-star" rendered="#{quickFilter.isDefaultFilter()}"/>
                            </h:commandLink>

                            <a4j:commandLink execute="@this"
                                             title="#{messages['net.ihe.gazelle.tm.DeleteQuickFilter']}"
                                             action="#{quickFilterBean.deleteSelectedQuickFilter(quickFilter)}"
                                             render="presetForm,globalForm,resultForm">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </h4>
                    </div>
                </a4j:repeat>
            </s:div>
        </h:form>
        <h:form id="globalForm" styleClass="form-horizontal">
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{testExecutionBeanGui.filter.urlParameters}"/>
            <script>
                updateUrl("globalForm:filterUrlParameters");
                $("#globalForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("globalForm:filterUrlParameters");
                    });
            </script>
            <div class="row search-criteria">
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterId" value="institution"/>
                        <ui:param name="filterName"
                                  value="#{messages['gazelle.users.Institution']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterId" value="system"/>
                        <ui:param name="filterName"
                                  value="#{messages['net.ihe.gazelle.tm.SystemUnderTest']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="testingDepth"/>
                        <ui:param name="filterName" value="#{messages['net.ihe.gazelle.tm.TestingDepth']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="statusResult"/>
                        <ui:param name="filterName" value="#{messages['gazelle.productregistry.crawler.Status']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="domain"/>
                        <ui:param name="filterName" value="#{messages['gazelle.tf.Domain']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterId" value="integrationProfile"/>
                        <ui:param name="filterName"
                                  value="#{messages['gazelle.testmanagement.object.Profile']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterId" value="actor"/>
                        <ui:param name="filterName"
                                  value="#{messages['gazelle.tf.Actor']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterId" value="integrationProfileOption"/>
                        <ui:param name="filterName"
                                  value="#{messages['gazelle.tf.IntegrationProfileOptionAcronym']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="transaction"/>
                        <ui:param name="filterName" value="#{messages['gazelle.tf.Transaction']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="testType"/>
                        <ui:param name="filterName" value="#{messages['gazelle.tm.tests.testType']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testExecutionBeanGui.filter}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="testPeerType"/>
                        <ui:param name="filterName" value="#{messages['gazelle.tm.tests.testPeerType']}"/>
                        <ui:param name="filterForm" value="globalForm,resultForm"/>
                    </ui:include>
                </div>

                <div class="col-lg-3">
                </div>
                <div class="col-lg-3">
                    <h4>
                        <a4j:commandLink actionListener="#{testExecutionBeanGui.clearFilters()}"
                                         title="#{messages['net.ihe.gazelle.tm.Reset']}"
                                         render="presetForm,globalForm,resultForm">
                            <span class="gzl-icon-stack">
                                <span class="fa-xl gzl-icon-filter gzl-icon-stack-1x"/>
                                <span class="gzl-icon-times gzl-icon-stack-1x gzl-icon-stack-bottom-right"/>
                            </span>
                        </a4j:commandLink>
                        <a4j:commandLink actionListener="#{testExecutionBeanGui.refreshPage()}"
                                         title="#{messages['gazelle.common.button.Refresh']}"
                                         render="globalForm,resultForm">
                            <span class="fa-xl gzl-icon-refresh"/>
                        </a4j:commandLink>
                        <a4j:commandLink title="#{messages['net.ihe.gazelle.tm.SaveSearchCriteria']}"
                                         render=":savePresetModalForm"
                                         oncomplete="jq162('#savePresetModal').modal('show');"
                                         immediate="true">
                            <span class="fa-xl gzl-icon-save "/>
                        </a4j:commandLink>
                    </h4>
                </div>
            </div>
            <div class="col-lg-7">
            </div>
            <label class="control-label col-lg-1">
                #{messages['net.ihe.gazelle.tm.SortBy']}
            </label>
            <div class="col-lg-2">
                <h:selectOneMenu styleClass="form-control gzl-select-text"
                                 id="sortMethod"
                                 value="#{testExecutionBeanGui.selectedSort}">
                    <s:selectItems
                            value="#{testExecutionBeanGui.getAllSortMethods()}"
                            var="sortUsed"
                            label="#{messages[sortUsed.getLabelToDisplay()]}"/>
                    <a4j:ajax event="change" execute="@this"
                              render="globalForm,resultForm"/>
                </h:selectOneMenu>
            </div>
            <div class="col-lg-2">
                <button type="button" class="gzl-btn-blue gzl-sut-report-button pull-right" onclick="collapseAll()">
                    #{messages['net.ihe.gazelle.tm.CollapseAll']}
                </button>
                <button type="button" class="gzl-btn-blue gzl-sut-report-button pull-right" onclick="expandAll()">
                    #{messages['net.ihe.gazelle.tm.ExpandAll']}
                </button>
            </div>
        </h:form>
        <h:form id="resultForm">
            <rich:dataGrid id="capabilityGrid" value="#{testExecutionBeanGui.getDataModel()}"
                           var="systemAIPOResult"
                           elements="#{dataScrollerMemory.numberOfResultsPerPage}"
                           columns="1" rowKeyVar="rowNumber" style="width:100%">
                <ui:include src="_capabilityGridElement.xhtml">
                    <ui:param name="sutReport" value="#{testExecutionBeanGui.getSutCapabilityReport(systemAIPOResult)}" />
                </ui:include>
                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="capabilityGridDs"/>
                        <ui:param name="dataTableId" value="capabilityGrid"/>
                    </ui:include>
                </f:facet>
            </rich:dataGrid>
            <script>
                function collapseAll() {
                    let icons = Array.prototype.slice.call(document.getElementsByClassName("changeIcon"));
                    icons.forEach(icon => {
                        icon.classList.remove("gzl-icon-collapse");
                        icon.classList.add("gzl-icon-expand");
                    })
                    jq162('.panel-collapse.in').collapse('hide');
                }
            </script>
            <script>
                function expandAll() {
                    let icons = Array.prototype.slice.call(document.getElementsByClassName("changeIcon"));
                    icons.forEach(icon => {
                        icon.classList.remove("gzl-icon-expand");
                        icon.classList.add("gzl-icon-collapse");
                    })
                    jq162('.panel-collapse:not(".in")').collapse('show');
                }
            </script>
        </h:form>

        <h:form id="partnersModalForm">
            <s:token allowMultiplePosts="true"/>
            <h:panelGroup rendered="true">
                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="partnersModal"/>
                    <ui:define name="popup_title">#{messages['net.ihe.gazelle.tm.Partners']}
                        #{messages['net.ihe.gazelle.tm.WithRole']}
                        #{testExecutionBeanGui.getSelectedPartnerReport().roleKeyword}
                    </ui:define>
                    <rich:dataTable value="#{testExecutionBeanGui.getSelectedPartnerReport().getPartnerSystemReports()}"
                                    var="partnerSystemReport">
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['gazelle.configuration.system.system']}"/>
                            </ui:define>
                            <h:outputText value="#{partnerSystemReport.systemKeyword}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['gazelle.systems.systemInSession.table']}"/>
                            </ui:define>
                            <h:outputText value="#{partnerSystemReport.table}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.tm.Tested']}"/>
                            </ui:define>
                            <span class="#{partnerSystemReport.getTestedStyleClass()}"/>
                        </g:column>
                    </rich:dataTable>
                </ui:decorate>
            </h:panelGroup>
        </h:form>

        <h:form id="savePresetModalForm">
            <s:token allowMultiplePosts="true"/>
            <h:panelGroup rendered="true">
                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="savePresetModal"/>
                    <ui:define name="popup_title">#{messages['net.ihe.gazelle.tm.NameOfPreset']}
                    </ui:define>
                    <div class="col-md-6">
                        <h:inputText id="masterModeleditTests" styleClass=" form-control"
                                     value="#{quickFilterBean.shortcutName}" maxlength="20"
                                     size="20"/>
                    </div>
                    <div class="col-md-2">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.tm.SaveSearchCriteria']}"
                                           styleClass="gzl-btn-green"
                                           action="#{quickFilterBean.createCookie(testExecutionBeanGui.getFilter())}"
                                           type="submit"
                                           render="presetForm,globalForm,resultForm"/>
                    </div>
                </ui:decorate>
            </h:panelGroup>
        </h:form>
    </ui:define>
</ui:composition>
